SystemOrganization addCategory: #'Math-QuaternionExtensions'!

!DhbPolynomial methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/5/2012 16:48:19.254'!
adaptToQuaternion: rcvr andSend: selector
	^(self class coefficients: (Array with: rcvr) ) perform: selector with: self! !

!DhbVector methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/5/2012 16:48:19.254'!
adaptToQuaternion: aQuaternion andSend: aByteSymbol 
	^ self collect: [:ea | aQuaternion perform: aByteSymbol  with: ea].! !

!Quaternion class methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:44'!
random
		"Answers a random quaternion with abs at most one."

	^ (0.5 - Float random) 
		i: (0.5 - Float random)
		j: (0.5 - Float random)
		k: (0.5 - Float random).! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 5/31/2012 12:05:19.968'!
addPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 19/4/99
		
		added to Quaternion 11 May 2012 Daniel Uber
		 "
	^aPolynomial addNumber: self! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:41'!
dividingPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/4/99 "
	^aPolynomial timesNumber: (1 / self)! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:41'!
productWithVector: aVector
		"Answers a new vector product of the receiver with aVector.
		 (c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 11/2/99 "
	^aVector collect: [ :each | each * self]! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:44'!
random
	"analog to Number>>random. The resulting quaternion will have abs at most that of the receiver"
	^ self class random * self.! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:42'!
subtractToPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 19/4/99 "
	^aPolynomial addNumber: self negated! !

!Quaternion methodsFor: '*Math-QuaternionExtensions' stamp: 'DanielUber 6/1/2012 16:42'!
timesPolynomial: aPolynomial
		"(c) Copyrights Didier BESSET, 1999, all rights reserved.
		 Initial code: 17/4/99 
		added to Complex class 12 May 2012, Daniel Uber
		"
	^aPolynomial timesNumber: self! !
